using System;
using System.Collections.Generic;
using System.Text;

namespace Commands
{
    public class Command<T> : ICommand<T>
    {
        #region ICommand<T> Members

        public event CommandHandler<T> Activated
        {
            add
            {
                if (value != null)
                    if (this.HandlerRegistered != null)
                        this.HandlerRegistered(value);
            }
            remove
            {
            }
        }

        public void Register(object control)
        {
            if (control != null)
                if (this.ControlRegistered != null)
                    this.ControlRegistered(control);
        }

        public void Enable()
        {
            if (this.EnabledRequested != null)
                this.EnabledRequested(null, null);
        }

        public void Disable()
        {
            if (this.DisabledRequested != null)
                this.DisabledRequested(null, null);
        }

        public void Activate()
        {
            if (this.ActivateRequested != null)
                this.ActivateRequested(null, null);
        }

        #endregion

        public event CommandHandlerRegisteredDelegate<T> HandlerRegistered;
        public event ComponentRegisteredDelegate ControlRegistered;
        public event EventHandler EnabledRequested;
        public event EventHandler DisabledRequested;
        public event EventHandler ActivateRequested;
    }

    public delegate void CommandHandlerRegisteredDelegate<T>(CommandHandler<T> handler);
    public delegate void ComponentRegisteredDelegate(object control);
}
