using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CommandsOld;

namespace WindowsApplication2
{
    public partial class Form1 : Form
    {
        ICommandManager<CommandsEnum> mgr = new CommandManager<CommandsEnum>();

        public Form1()
        {
            InitializeComponent();

            this.mgr.Register(CommandsEnum.Command1, toolStripButton1);
            this.mgr.Register(CommandsEnum.Command1, command1ToolStripMenuItem);
            this.mgr.Register(CommandsEnum.Command2, toolStripButton2);
            this.mgr.Register(CommandsEnum.Command2, command2ToolStripMenuItem);

            this.mgr.Register(CommandsEnum.Command1, new CommandHandler<CommandsEnum>(this.command1_activated));
            this.mgr.Register(CommandsEnum.Command2, new CommandHandler<CommandsEnum>(this.command2_activated));
        }

        void command1_activated()
        {
            MessageBox.Show("command1");
        }

        void command2_activated()
        {
            MessageBox.Show("command2");
        }

        private void enable1_Click(object sender, EventArgs e)
        {
            this.mgr.Enable(CommandsEnum.Command1);
        }

        private void disable1_Click(object sender, EventArgs e)
        {
            this.mgr.Disable(CommandsEnum.Command1);
        }

        private void enable2_Click(object sender, EventArgs e)
        {
            this.mgr.Enable(CommandsEnum.Command2);
        }

        private void disable2_Click(object sender, EventArgs e)
        {
            this.mgr.Disable(CommandsEnum.Command2);
        }

        private void activate1_Click(object sender, EventArgs e)
        {
            this.mgr.Activate(CommandsEnum.Command1);
        }
    }

	public enum CommandsEnum { Command1, Command2 }
}